<?php

namespace Myriad\EventDrivenService\Http\Utilities;

use Myriad\EventDrivenService\Models\EventModel;

class EventBuilder {

  public static function make($model, $data, $formatter = null) {
    $command = $model . ':update';
    $value = $data;
    if ($data->deleted_at) {
      $command = $model . ':delete';
      $value = null;
    }
    return [
      'command' => $command,
      'model_uuid' => $data->uuid,
      'value' => self::format($value, $formatter)
    ];
  }

  private static function format($value, $formatter) {
    if (!$value) {
      return null;
    }

    if ($value instanceof EventModel) {
      return $value->format();
    }

    if ($formatter && class_exists($formatter)) {
      return app()->makeWith($formatter, ['resource' => $value]);
    }

    return $value;
  }
}